    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <fstream>
#include <string>
using namespace std;

#ifndef __o3instream__
#define __o3instream__

#include "o3comment.h"
#include "o3linebuffer.h"

class InputStream : public ifstream {
public:
					InputStream();
					~InputStream();
	void			open(const string& filename);
	void			usecinstream();
	LOb*			read();
	void			readRaw(char* dst, int bytes);
	size_t			gcount();
	
	bool			eof()			const;
	bool			eoLOb()		const;
	const string&	src()			const;
	bool			streameof()	const;

private:
	string			filename;
	int				remainingdata;
	bool			endofLOb;
	bool			binarydatafollows;
	bool			usecin;
	LineBuffer		linebuffer;		// linebuffer(65536) called by InputStream()

	bool			CMP(const string& str1, const char *str2);
	bool			CMP(const string& str1, const string& str2);
	
	void			onBeginData(const CommentLOb& comment);
	void			onBeginBinary(const CommentLOb& comment);

} extern *inputstream;

#endif // __o3instream__
