    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#ifndef __o3opiheader__
#define __o3opiheader__

#include <map>
using namespace std;
#include "o3headeritem.h"

class OPIHeader {
public:
	enum HI_ID {
		HI_aldimagefilename,
		HI_aldimageid,
		HI_aldobjectcomments,
		HI_aldimagedimensions,
		HI_aldimagecroprect,
		HI_aldimagecropfixed,
		HI_aldimageposition,
		HI_aldimageresolution,
		HI_aldimagecolortype,
		HI_aldimagecolor,
		HI_aldimagetint,
		HI_aldimageoverprint,
		HI_aldimagetype,
		HI_aldimagegraymap,
		HI_aldimagetransparency,
		HI_beginobject,
		HI_imageoperands,

		HI_beginopi,
		HI_distilled,
		HI_imagefilename,
		HI_mainimage,
		HI_imagedimensions,
		HI_imagecroprect,
		HI_imageoverprint,
		HI_imageinks,
		HI_graphicsstate,
		HI_beginincludedimage,
		HI_includedimagedimensions,
		HI_includedimagetype,
		HI_includedimagequality,

		HI_beginbinary,
		HI_begindata
	};

	enum HIM_ID {
		HIM_tiffasciitags,
		HIM_aldimageasciitags
	};

							OPIHeader();
	OPIHeader				*clone();
	HeaderItem				*headerItem(HI_ID hiid);
	map<int, HeaderItem>	*headerItemMap(HIM_ID himid);

private:
	HeaderItem				aldimagefilename;
	HeaderItem				aldimageid;
	HeaderItem				aldobjectcomments;
	HeaderItem				aldimagedimensions;
	HeaderItem				aldimagecroprect;
	HeaderItem				aldimagecropfixed;
	HeaderItem				aldimageposition;
	HeaderItem				aldimageresolution;
	HeaderItem				aldimagecolortype;
	HeaderItem				aldimagecolor;
	HeaderItem				aldimagetint;
	HeaderItem				aldimageoverprint;
	HeaderItem				aldimagetype;
	HeaderItem				aldimagegraymap;
	HeaderItem				aldimagetransparency;
//	HeaderItem				aldimageasciitag;
	HeaderItem				beginobject;
	HeaderItem				imageoperands;

	HeaderItem				beginopi;
	HeaderItem				distilled;
	HeaderItem				imagefilename;
	HeaderItem				mainimage;
//	HeaderItem				tiffasciitag;
	HeaderItem				imagedimensions;
	HeaderItem				imagecroprect;
	HeaderItem				imageoverprint;
	HeaderItem				imageinks;
	HeaderItem				graphicsstate;
	HeaderItem				beginincludedimage;
	HeaderItem				includedimagedimensions;
	HeaderItem				includedimagetype;
	HeaderItem				includedimagequality;
//	HeaderItem				imageoperands;
							
	HeaderItem				beginbinary;
	HeaderItem				begindata;

	map<int, HeaderItem>	tiffasciitags;
	map<int, HeaderItem>	aldimageasciitags;
};

#endif // __o3opiheader__
