#include "o3path3mapper.h"

Path3Mapper *path3mapper;

Path3Mapper::Path3Mapper()
{
}

Path3Mapper::~Path3Mapper()
{
	map<Path3*, Path3*>::iterator i;

	for (i = paths.begin(); i != paths.end(); ++i) {
		delete i->first;
		delete i->second;
	}
}

void Path3Mapper::addMapping(const string &match, const string &dest)
{
	paths.insert(map<Path3*, Path3*>::value_type(new Path3(match, false), new Path3(dest, false)));
}

void Path3Mapper::mapFilePath(Path3 &path3)
{
	map<Path3*, Path3*>::iterator i;

	for (i = paths.begin(); i != paths.end(); ++i)
		if (path3.convertPath(*i->first, *i->second))
			break;
}
